package eai;

import java.util.Date;
import java.util.Random;

import javax.annotation.Resource;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;
import javax.ejb.Timeout;
import javax.ejb.Timer;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 * Session Bean implementation class LotteryBean
 */
@Stateless
public class LotteryBean implements LotteryBeanRemote {
	
	private static int interval=120000;
	private static Date nextDraw;
	private static int number;
	
	private @Resource SessionContext ctx;

    public void scheduleTimer(long ms){
//    	System.out.println(ctx.getTimerService().getTimers().size());
    	long next=System.currentTimeMillis()+ms;
    	this.setNextDraw(new Date(next));
    	ctx.getTimerService().createTimer(new Date(next), "new timer created");
    }
    
    @Timeout
    public void timeout(Timer timer){
    	number=new Random().nextInt(100)+1;
    	System.out.println("v7: "+number);
    	InitialContext ctx;
    	this.scheduleTimer(interval);
    	
    	try {
			ctx = new InitialContext();
			LotteryServerBeanRemote cb=(LotteryServerBeanRemote)ctx.lookup("LotteryServerBean/remote");
			
			cb.newDraw();
			
		} catch (NamingException e) {
			System.out.println("ERROR in connection of lottery service");
		} 	
    }

	public Date getNextDraw() {
		return nextDraw;
	}

	public void setNextDraw(Date nextDraw) {
		this.nextDraw = nextDraw;
	}
	
	public int getNumber(){
		return this.number;
	}
	
	public void ClearTimers(){
		ctx.getTimerService().getTimers().clear();
	}
}
