/*==============================================================*/
/* DBMS name:      MySQL 5.0                                    */
/* Created on:     12-10-2011 16:49:32                          */
/*==============================================================*/


drop table if exists BET;

drop table if exists LOTTERY;

drop table if exists MESSAGE;

drop table if exists PHOTO;

drop table if exists RELATION;

drop table if exists CLIENT;

create table BET
(
   ID               int not null AUTO_INCREMENT,
   ID_CLIENT              int not null,
   ID_LOTTERY            int not null,
   NUMBER               int not null,
   primary key (ID)
);
create table LOTTERY
(
   ID			       int not null AUTO_INCREMENT,
   LOTTARY_DATE             datetime not null,
   RESULT               int,
   primary key (ID)
);
create table MESSAGE
(
   ID	             int not null AUTO_INCREMENT,
   ID_CLIENT_FROM              int not null,
   ID_CLIENT_TO              int not null,
   ID_PHOTO             int,
   IS_PRIVATE              bool not null,
   TEXT                 varchar(150),
   IS_READ               bool not null,
   MSG_DATE             datetime not null,
   primary key (ID)
);

create table PHOTO
(
   ID             int not null AUTO_INCREMENT,
   PATH                 varchar(500) not null,
   primary key (ID)
);
create table RELATION
(
   ID							int not null AUTO_INCREMENT,
   ID_CLIENT_FROM               int not null,
   ID_CLIENT_TO                   int not null,
   STATUS               char(1) not null,
   primary key (ID)
);
create table CLIENT
(
   ID_PHOTO             int,
   ID                   int not null AUTO_INCREMENT,
   PASSWORD             varchar(20) not null,
   NAME                 varchar(50) not null,
   GENDER               char(1) not null,
   EMAIL                varchar(50) not null UNIQUE,
   MONEY                float not null,
   primary key (ID)
);

alter table BET add constraint FK_LOT_HAVE_BET foreign key (ID_LOTTERY)
      references LOTTERY (ID) on delete restrict on update restrict;

alter table BET add constraint FK_CLIENT_HAVE_BET foreign key (ID_CLIENT)
      references CLIENT (ID) on delete restrict on update restrict;

alter table MESSAGE add constraint FK_FROM_RELATION foreign key (ID_CLIENT_FROM)
      references CLIENT (ID) on delete restrict on update restrict;
	  
alter table MESSAGE add constraint FK_TO_RELATION foreign key (ID_CLIENT_TO)
      references CLIENT (ID) on delete restrict on update restrict;

alter table MESSAGE add constraint FK_MSG_HAVE foreign key (ID_PHOTO)
      references PHOTO (ID) on delete restrict on update restrict;

alter table RELATION add constraint FK_RELATION_TO foreign key (ID_CLIENT_FROM)
      references CLIENT (ID) on delete restrict on update restrict;

alter table RELATION add constraint FK_RELATION_FROM foreign key (ID_CLIENT_TO)
      references CLIENT (ID) on delete restrict on update restrict;

alter table CLIENT add constraint FK_CLIENT_PHOTO foreign key (ID_PHOTO)
      references PHOTO (ID) on delete restrict on update restrict;

